using System;
using System.Collections.Generic;
using jp.netgamers.free.tuogl;	//	OpenGL ̔bp[ڎwĂ
using jp.netgamers.free.tugame;	//	OpenGL ̃CuڎwĂ

class MyPrimitive
{
	public short[]	va;
	public uint[]	ca;

	public MyPrimitive( String path )
	{
		va = TUAssets.readTSVArray<short>( path + "/vertex.tsv" );
		ca = TUAssets.readTSVArray<uint>( path + "/color.tsv" );
	}

	public void draw( float x, float y, float z, float a )
	{
		GL1.VertexPointer( 3, va );	//	_W̐ݒ
		GL1.ColorPointer(			//	F̐ݒ
		 4,							//	F̗vf
		 GL1._UNSIGNED_BYTE,		//	f[^̌^
		 0,							//	f[^Ԋu
		 ca );						//	Ff[^

		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Translatef( x, y, z );	//	sړ
		GL1.Rotatef( a, 0, 0, 1 );	//	Zŉ]
		GL1.DrawArrays(				//	z`
		 GL1._TRIANGLES,			//	Op`̕`
		 0,							//	Jnʒu
		 va.Length / 3 );			//	_
		GL1.PopMatrix();			//	}gbNXX^bNo
	}

}

class MyModel
{
	public static String[]	Name = { "Building","Hatake","House","Azemichi","Jisya","Platform","Rail","Train" };
	public static Dictionary<String, MyPrimitive>	Pri = new Dictionary<String, MyPrimitive>();

	public static void load()
	{
		foreach( String s in Name ){
			Pri[ s ] = new MyPrimitive( s );
		}
	}
}

class MyMap
{
	public static sbyte[]	Data = new sbyte[ 32 * 32 ];
	public static sbyte[]	Angle = new sbyte[ 32 * 32 ];

	public static void draw()
	{
		for( int i = 0; i < Data.Length; i++ ){
			if( Data[ i ] > 0 ){
				MyModel.Pri[ MyModel.Name[ Data[ i ] - 1 ] ].draw( ( i % 32 - 16 ) * 100, ( i / 32 - 16 ) * 100, 0, Angle[ i ] );
			}
		}
	}

	public static void init()
	{
		for( int i = 0; i < 30; i++ ){
			MyMap.Data[ TUGame.rnd( 32 ) * 32 + TUGame.rnd( 32 ) ] = 1;
		}

		for( int i = 0; i < 500; i++ ){
			MyMap.Data[ TUGame.rnd( 32 ) * 32 + TUGame.rnd( 32 ) ] = 2;
		}

		for( int i = 0; i < 50; i++ ){
			MyMap.Data[ TUGame.rnd( 32 ) * 32 + TUGame.rnd( 32 ) ] = 3;
		}

		for( int y = 0; y < 32; y++ ){
			MyMap.Data[ y * 32 + 16 ] = 4;
			MyMap.Angle[ y * 32 + 16 ] = 90;
		}

		for( int x = 0; x < 32; x++ ){
			MyMap.Data[ 16 * 32 + x ] = 5;
			MyMap.Angle[ 16 * 32 + x ] = 0;
		}

		for( int x = 10; x < 23; x++ ){
			MyMap.Data[ 16 * 32 + x ] = 6;
		}
	}
}

class ETrain : TURetroGame
{
	static float		PX;		//	vC[̍W
	static int			Score;		//	_

	public override void wmCreated()
	{
		Title = "Edɏ낤";
		MyMap.init();
		MyModel.load();
		setFrameRate( 60 );
	}

	public override void wmTimer()
	{
		Score++;
		PX += 2;
		Invalidate();	//	ĕ`˗
	}

	public override void wmDraw()
	{
		GL1.ClearColor( 0xffcccc77 );	//	ʃNA̐Fw
		GL1.Clear(					//	ʃNA
		 GL1._DEPTH_BUFFER_BIT |	//	[xobt@
		 GL1._COLOR_BUFFER_BIT );	//	Fobt@
		GL1.LoadIdentity();			//	ftHg̃}gbNXǂݍ
		GL1.Scale( 0.0453f );		//	XP[ύXBglScalef( 0.0453f, 0.0453f, 0.0453f );
		GL1.LookAt(					//	_ݒ
		  -1,  -1,  0.817f,			//	J̈ʒu
		   0,   0,  0,				//	Jʂ̒
		   0,   0,  1 );			//	J̌

		GL1.Enable( GL1._DEPTH_TEST );	//	[xeXgL
		GL1.EnableClientState( GL1._COLOR_ARRAY );	//	FzL

		//	[`
		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Scalef( 100, 1, 1 );	//	XP[ύX
		MyModel.Pri[ "Rail" ].draw( 0, -11, 0, 0 );
		MyModel.Pri[ "Rail" ].draw( 0,  11, 0, 0 );
		GL1.PopMatrix();			//	}gbNXX^bNo


		//	`
		MyMap.draw();

		//	Ԃ`
		for( int i = 0; i < 12; i++ ){
			MyModel.Pri[ "Train" ].draw( PX - i * 100, 0, 0, 0 );
		}

		GL1.DisableClientState( GL1._COLOR_ARRAY );	//	Fz𖳌
		GL1.Disable( GL1._DEPTH_TEST );
		GL1.LoadIdentity();				//	ftHg̃}gbNXǂݍ
		draw( "SCORE " + Score );
	}

	static void Main()
	{
		new ETrain();
	}
}
